#include "stm32f10x_type.h"
#include "nrf24l01.h"
#include "spi.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_gpio.h"
#include "delays.h"

#define BLUE_LED 8
#define GREEN_LED 9

void led_flash(u16 LENn);

int main(void)
{
	RF_InitTypeDef RF_InitStruct;
	GPIO_InitTypeDef GPIO_InitStruct;

	init_all();	

	RF_InitStruct.RF_Power_State=RF_Power_On;
	RF_InitStruct.RF_Config=RF_Config_IRQ_RX_On|RF_Config_IRQ_TX_On|RF_Confing_IRQ_Max_Rt_Off;
	RF_InitStruct.RF_CRC_Mode=RF_CRC_Off;
	RF_InitStruct.RF_Mode=RF_Mode_RX;
	RF_InitStruct.RF_Pipe_Auto_Ack=RF_Pipe_All_Ack_Disable;
	RF_InitStruct.RF_Enable_Pipe=RF_Pipe0_Enable;
	RF_InitStruct.RF_Setup=RF_Setup_3_Byte_Adress;
	RF_InitStruct.RF_TX_Power=RF_TX_Power_High;
	RF_InitStruct.RF_Data_Rate=RF_Data_Rate_1Mbs;
	RF_InitStruct.RF_Channel=10;
	RF_InitStruct.RF_RX_Adress_Pipe0[0]=0xDE;
	RF_InitStruct.RF_RX_Adress_Pipe0[1]=0xAE;
	RF_InitStruct.RF_RX_Adress_Pipe0[2]=0xEE;
	RF_InitStruct.RF_RX_Adress_Pipe0[3]=0xCE;
	RF_InitStruct.RF_RX_Adress_Pipe0[4]=0xFE;
	RF_InitStruct.RF_TX_Adress[0]=0xDE;
	RF_InitStruct.RF_TX_Adress[1]=0xAE;
	RF_InitStruct.RF_TX_Adress[2]=0xEE;
	RF_InitStruct.RF_TX_Adress[3]=0xCE;
	RF_InitStruct.RF_TX_Adress[4]=0xFE;
	RF_InitStruct.RF_Payload_Size_Pipe0=1;
	RF_InitStruct.RF_Auto_Retransmit_Count=0;
	RF_Init(&RF_InitStruct,0);

	//RF_IRQ_CLEAR(RF_RX_DR_IRQ_CLEAR|RF_TX_DS_IRQ_CLEAR|RF_MAX_RT_IRQ_CLEAR);

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC,ENABLE);
	GPIO_InitStruct.GPIO_Pin=GPIO_Pin_8;
	GPIO_InitStruct.GPIO_Mode=GPIO_Mode_Out_PP;
	GPIO_InitStruct.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &GPIO_InitStruct);

	while(1)
	{
			if (RF_Receive_Data(1)!=0xFF) {led_flash(BLUE_LED);}
	}
}

void led_flash(u16 LENn)
{
		if ((GPIOC->IDR&(1<<LENn))!=0)
			{GPIOC->ODR&=~(1<<LENn);}
		else
			{GPIOC->ODR|=(1<<LENn);}
}
