#include "nrf24l01.h"

u8 Received_Data[Max_Dala_Len];

void RF_Init(RF_InitTypeDef* RF_InitStruct,u8 fast)		   //if fast<>0 using short programming only for change RF_Mode RX/TX
{	
	PIN_OFF(CE_GPIO, CE);
	PIN_ON(CSN_GPIO, CSN);
	if (fast==0){delay_ms(Init_Delay_ms);}
	RF_Send_Cmd(CONFIG_REG,(RF_InitStruct->RF_Config|RF_InitStruct->RF_Power_State|RF_InitStruct->RF_CRC_Mode|RF_InitStruct->RF_Mode));
	if (fast==0)
	{															
		RF_Send_Cmd(EN_AA_REG,RF_InitStruct->RF_Pipe_Auto_Ack);										//EN_AA 		REG
		RF_Send_Cmd(EN_RXADDR_REG,RF_InitStruct->RF_Enable_Pipe);									//EX_RXADDR		REG
		RF_Send_Cmd(SETUP_AW_REG,RF_InitStruct->RF_Setup);											//SETUP_AW		REG
		RF_Send_Cmd(SETUP_RETR_REG,(RF_InitStruct->RF_Auto_Retransmit_Count&0x0F)|(((RF_InitStruct->RF_Auto_Retransmit_Delay)&0x0F)<<4));
		RF_Send_Cmd(RF_CH_REG,(RF_InitStruct->RF_Channel&0x7F));									//RF Chanel		REG
		RF_Send_Cmd(RF_SETUP_REG,(0x01|RF_InitStruct->RF_TX_Power|RF_InitStruct->RF_Data_Rate));	//RF_SETUP		REG
		RF_Send_Adrs(RX_ADDR_P0_REG,RF_InitStruct->RF_RX_Adress_Pipe0);								//RX adress for PIPE0
		RF_Send_Adrs(RX_ADDR_P1_REG,RF_InitStruct->RF_RX_Adress_Pipe1);								//RX adress for PIPE1
		RF_Send_Cmd(RX_ADDR_P2_REG,RF_InitStruct->RF_RX_Adress_Pipe2);								//RX adress for PIPE2 (only LSB) 
		RF_Send_Cmd(RX_ADDR_P3_REG,RF_InitStruct->RF_RX_Adress_Pipe3);								//RX adress for PIPE3 (only LSB)
		RF_Send_Cmd(RX_ADDR_P4_REG,RF_InitStruct->RF_RX_Adress_Pipe4);								//RX adress for PIPE4 (only LSB)
		RF_Send_Cmd(RX_ADDR_P5_REG,RF_InitStruct->RF_RX_Adress_Pipe5);								//RX adress for PIPE5 (only LSB)
		RF_Send_Adrs(TX_ADDR_REG,RF_InitStruct->RF_TX_Adress);
		RF_Send_Cmd(RX_PW_P0_REG,RF_InitStruct->RF_Payload_Size_Pipe0);
		RF_Send_Cmd(RX_PW_P1_REG,RF_InitStruct->RF_Payload_Size_Pipe1);
		RF_Send_Cmd(RX_PW_P2_REG,RF_InitStruct->RF_Payload_Size_Pipe2);
		RF_Send_Cmd(RX_PW_P3_REG,RF_InitStruct->RF_Payload_Size_Pipe3);
		RF_Send_Cmd(RX_PW_P4_REG,RF_InitStruct->RF_Payload_Size_Pipe4);
		RF_Send_Cmd(RX_PW_P5_REG,RF_InitStruct->RF_Payload_Size_Pipe5);
	}
	PIN_ON(CSN_GPIO, CSN);
	PIN_ON(CE_GPIO, CE);			 
}

void RF_Send_Cmd(u8 adrs, u8 cmd)							//write data to register procedure
{	
	PIN_OFF(CE_GPIO, CE);
	PIN_OFF(CSN_GPIO, CSN);
	SPI_SendByte((0x1F&adrs)|(1<<5));
	SPI_SendByte(cmd);
	PIN_ON(CSN_GPIO, CSN);
}
u8 RF_Read_Cmd(u8 adrs)										//read data from register
{
	u8 tmp;
	PIN_OFF(CE_GPIO, CE);
	PIN_OFF(CSN_GPIO, CSN);
	SPI_SendByte(0x1F&adrs);
	tmp=SPI_ReadByte(0xFF);
	PIN_ON(CSN_GPIO, CSN);
	PIN_ON(CE_GPIO, CE);
	return tmp;
}

void RF_Send_Adrs(u8 adrs, u8 cmd[Max_Adress_Len])
{
	u8 tmp=0;
	PIN_OFF(CSN_GPIO, CSN);
	SPI_SendByte(adrs|(1<<5));
	while (tmp<Max_Adress_Len)
	{
		SPI_SendByte(cmd[tmp]);
		tmp++;
	}
	PIN_ON(CSN_GPIO, CSN);
}

u8 RF_Send_Data(u8 Data[Max_Dala_Len],u8 Dala_Len)			//returns 1 if data send succesfuly, Data_Len = num of bytes to send
{
	u8 cnt=0;
	PIN_OFF(CE_GPIO, CE);
	PIN_OFF(CSN_GPIO, CSN);
	SPI_SendByte(0xA0);				  						//W_TX_PAYLOAD Command
	while (cnt<Dala_Len)
	{
		  SPI_SendByte(Data[cnt]);
		  cnt++;
	}
	PIN_ON(CSN_GPIO, CSN);
	PIN_ON(CE_GPIO, CE);
	delay_us(TX_Delay_us);
	if ((IRQ_GPIO->IDR&IRQ)!=0)
		{cnt = 0;}
	else
		{cnt = 1;}
	PIN_OFF(CE_GPIO, CE);
	RF_IRQ_CLEAR(RF_TX_DS_IRQ_CLEAR);
	return cnt;
}   

u8 RF_Receive_Data(u8 Dala_Len)					  			//returns 0xFF if no data received. Data_Len = num of bytes to receive
{														  	//returns PIPE num if data received succesfully
	u8 cnt=0;												//all received data fills Received_Data[Dala_Len] array
	u8 tmp=0;
	if ((IRQ_GPIO->IDR&IRQ)!=0)
	{
		return 0xFF;
	}
	else
	{	
		PIN_OFF(CE_GPIO, CE);
		PIN_OFF(CSN_GPIO, CSN);
		tmp = (SPI_ReadByte(0x61)&0x0E);					//read status reg and send R_RX_PAYLOAD Command																  	
		while (cnt<Dala_Len)
		{
			Received_Data[cnt]=SPI_ReadByte(0xFF);
			cnt++;	
		}
		PIN_ON(CSN_GPIO, CSN);
		PIN_ON(CE_GPIO, CE);
		RF_IRQ_CLEAR(RF_RX_DR_IRQ_CLEAR);
		return tmp;
	}			
}

u8 RF_Carrier_Detect(void)										//returns 1 if Carrier Detected on current channel
	{return (RF_Read_Cmd(CD_REG)&0x01);}

u8 RF_Count_Lost_Packets(void)									//returns num of Lost Packatets 
	{return (((RF_Read_Cmd(OBSERV_TX_REG))&0xF0)>>4);}

u8 RF_Count_Resend_Packets(void)								//returns nut of Resend Packets
	{return ((RF_Read_Cmd(OBSERV_TX_REG))&0x0F);}

void RF_IRQ_CLEAR (u8 CMD)											//Clears IRQ
	{RF_Send_Cmd(STATUS_REG, CMD);PIN_ON(CE_GPIO, CE);} 

u8 RF_Single_Package_Send(u8 Data[Max_Dala_Len],u8 Dala_Len)	//enters TX mode, sends a package and returns to RX mode
{																//returns 1 if data send succesfuly, Data_Len = num of bytes to send
    u8 tmp1;
    u8 tmp2=RF_Read_Cmd(CONFIG_REG);
	RF_Send_Cmd(CONFIG_REG,(tmp2&0xFE));  						//set TX mode
	tmp1=RF_Send_Data(Data,Dala_Len);							//send data
	RF_Send_Cmd(CONFIG_REG,(tmp2|0x01));						//SET RX mode
	PIN_ON(CE_GPIO, CE);										//ON AIR mode
	return tmp1;
}
