#include "spi.h"
							
void init_all (void)
{
	init_RCC();
	init_GPIO();
	init_SPI();
	PIN_ON(CSN_GPIO, CSN);
}

void init_RCC (void)
{
	if (CE_GPIO==GPIOA|IRQ_GPIO==GPIOA|CSN_GPIO==GPIOA){RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA,ENABLE);}
	if (CE_GPIO==GPIOB|IRQ_GPIO==GPIOB|CSN_GPIO==GPIOB){RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB,ENABLE);}
	if (CE_GPIO==GPIOC|IRQ_GPIO==GPIOC|CSN_GPIO==GPIOC){RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC,ENABLE);}
	if (CE_GPIO==GPIOD|IRQ_GPIO==GPIOD|CSN_GPIO==GPIOD){RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD,ENABLE);}
	if (CE_GPIO==GPIOE|IRQ_GPIO==GPIOE|CSN_GPIO==GPIOE){RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOE,ENABLE);}

	if (SPIxx==SPI1){RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1,ENABLE);}
	if (SPIxx==SPI2){RCC_APB2PeriphClockCmd(RCC_APB1Periph_SPI2,ENABLE);}
	if (SPIxx==SPI3){RCC_APB2PeriphClockCmd(RCC_APB1Periph_SPI3,ENABLE);}
}

void init_GPIO(void)
{
	GPIO_InitTypeDef GPIO_InitStruct;

	GPIO_InitStruct.GPIO_Pin=CE;
	GPIO_InitStruct.GPIO_Mode=GPIO_Mode_Out_PP;
	GPIO_InitStruct.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_Init(CE_GPIO, &GPIO_InitStruct);

	GPIO_InitStruct.GPIO_Pin=CSN;
	GPIO_Init(CSN_GPIO, &GPIO_InitStruct);

	GPIO_InitStruct.GPIO_Mode=GPIO_Mode_IN_FLOATING;
	GPIO_InitStruct.GPIO_Pin=IRQ;
	GPIO_Init(IRQ_GPIO, &GPIO_InitStruct);

	if (SPIxx==SPI1)
	{
		GPIO_InitStruct.GPIO_Pin=GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7;		 //alternative func for SPI
		GPIO_InitStruct.GPIO_Mode=GPIO_Mode_AF_PP;
		GPIO_InitStruct.GPIO_Speed=GPIO_Speed_50MHz;
		GPIO_Init(GPIOA, &GPIO_InitStruct);
	}
	if (SPIxx==SPI2)
	{
		GPIO_InitStruct.GPIO_Pin=GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15;	 //alternative func for SPI
		GPIO_InitStruct.GPIO_Mode=GPIO_Mode_AF_PP;
		GPIO_InitStruct.GPIO_Speed=GPIO_Speed_50MHz;
		GPIO_Init(GPIOB, &GPIO_InitStruct);
	}
}

void init_SPI	(void)
{
	SPI_InitTypeDef SPI_InitStruct;
	SPI_InitStruct.SPI_Direction=SPI_Direction_2Lines_FullDuplex;
	SPI_InitStruct.SPI_Mode=SPI_Mode_Master;
	SPI_InitStruct.SPI_DataSize=SPI_DataSize_8b;
	SPI_InitStruct.SPI_CPOL=SPI_CPOL_Low;
	SPI_InitStruct.SPI_CPHA=SPI_CPHA_1Edge;
	SPI_InitStruct.SPI_NSS=SPI_NSS_Soft;
	SPI_InitStruct.SPI_BaudRatePrescaler=SPI_BaudRatePrescaler_8;
	SPI_InitStruct.SPI_FirstBit=SPI_FirstBit_MSB;
	SPI_InitStruct.SPI_CRCPolynomial=7;
	SPI_Init(SPIxx, &SPI_InitStruct);

	SPI_Cmd(SPIxx, ENABLE);
}

void SPI_SendByte(u8 byte)
{
	u8 tmp=SPI_ReadByte(byte);	
}

u8 SPI_ReadByte(u8 byte)
{
    /* Loop while DR register in not emplty */
  while (SPI_I2S_GetFlagStatus(SPIxx, SPI_I2S_FLAG_TXE) == RESET);

  /* Send byte through the SPI1 peripheral */
  SPI_I2S_SendData(SPIxx, byte);

  /* Wait to receive a byte */
  while (SPI_I2S_GetFlagStatus(SPIxx, SPI_I2S_FLAG_RXNE) == RESET);

  /* Return the byte read from the SPI bus */
  return SPI_I2S_ReceiveData(SPIxx);
}

void Delay(u32 nTime)
{ 
  while(nTime != 0)
  {nTime--;}
}
